<template>
	<section class="FieldsViewControlsMobile" aria-label="filters">
		<fields-view-search-input />

		<v-dialog v-model="showDialog" fullscreen hide-overlay>
			<template v-slot:activator="{ on, attrs }">
				<v-btn class="FieldsViewControlsMobile-dialogButton" v-bind="attrs" v-on="on" outlined icon tile>
					<v-icon>mdi-tune</v-icon>
				</v-btn>
			</template>

			<v-card>
				<v-toolbar color="#f5f5f5" class="FieldsViewControlsMobile-dialogToolbar">
					<v-toolbar-title>Filter Field Results</v-toolbar-title>
					<v-spacer />
					<v-btn icon @click="showDialog = false">
						<v-icon>mdi-close</v-icon>
					</v-btn>
				</v-toolbar>
				<div class="FieldsViewControlsMobile-filters">
					<fields-view-group-filter class="FieldsViewControlsMobile-control" />
					<fields-view-recent-activity-filter class="FieldsViewControlsMobile-control" />
					<fields-view-status-filter class="FieldsViewControlsMobile-control" />
					<fields-view-sort-by class="FieldsViewControlsMobile-control" />
					<button class="FieldsViewControlsMobile-clearAll primary--text" @click="clearAllFilters">
						Clear all filters
					</button>
					<v-btn class="FieldsViewControlsMobile-viewResults" dark large color="primary" @click="showDialog = false">
						View Results ({{ fieldRowsLength }})
					</v-btn>
				</div>
			</v-card>
		</v-dialog>

		<v-menu offset-y v-model="showExportCSV">
			<template v-slot:activator="{ on, attrs }">
				<v-btn
					class="FieldsViewControlsMobile-dialogButton FieldsViewControlsMobile-tripleDot"
					v-bind="attrs"
					v-on="on"
					icon
					tile
					:width="15"
					color="#000000de"
				>
					<v-icon>mdi-dots-vertical</v-icon>
				</v-btn>
			</template>
			<v-list class="pa-0">
				<fields-view-export-csv @ok="showExportCSV = false" />

				<add-stratification-dialog v-slot="{ attrs, on }" @open="showExportCSV = false">
					<v-list-item v-bind="attrs" v-on="on">
						<v-list-item-title>Add Stratification</v-list-item-title>
					</v-list-item>
				</add-stratification-dialog>
			</v-list>
		</v-menu>
	</section>
</template>

<script lang="ts">
import { computed, defineComponent, ref, watch } from '@vue/composition-api';
import AddStratificationDialog from '@/components/dialog/AddStratificationDialog.vue';
import { useFieldsView } from '@/store/modules/fieldsView';
import FieldsViewExportCsv from './FieldsViewExportCsv.vue';
import FieldsViewGroupFilter from './FieldsViewGroupFilter.vue';
import FieldsViewRecentActivityFilter from './FieldsViewRecentActivityFilter.vue';
import FieldsViewSearchInput from './FieldsViewSearchInput.vue';
import FieldsViewSortBy from './FieldsViewSortBy.vue';
import FieldsViewStatusFilter from './FieldsViewStatusFilter.vue';

export default defineComponent({
	components: {
		FieldsViewSearchInput,
		FieldsViewGroupFilter,
		FieldsViewRecentActivityFilter,
		FieldsViewStatusFilter,
		FieldsViewSortBy,
		FieldsViewExportCsv,
		AddStratificationDialog,
	},
	setup(_, { root }) {
		const showDialog = ref(false);
		const showExportCSV = ref(false);
		const fieldRowsLength = computed(() => root.$store.getters['fieldsView/getFieldRowsLength']);
		const { resetOpenedGroupIds } = useFieldsView(root.$store);

		watch(showDialog, () => {
			if (showDialog.value) {
				resetOpenedGroupIds();
			}
		});

		return {
			showDialog,
			showExportCSV,
			fieldRowsLength,
			clearAllFilters: () => {
				root.$store.dispatch('fieldsView/clearAllFilters');
			},
		};
	},
});
</script>

<style lang="scss">
.FieldsViewControlsMobile-dialogButton {
	margin-right: 16px;
	background: #fff;

	&.FieldsViewControlsMobile-tripleDot {
		background: inherit;
	}

	&.v-btn--tile {
		border-radius: 4px;
	}

	&.v-btn--icon.v-size--default {
		width: 40px;
		height: 40px;
	}
}

.v-dialog--fullscreen {
	background: #fff !important;
}

.FieldsViewControlsMobile {
	display: flex;

	.FieldsViewSearchInput {
		flex-grow: 1;
		margin: 0 16px;
	}
}

.FieldsViewControlsMobile-dialogToolbar {
	position: fixed;
	top: 0;
	width: 100%;
	z-index: 1;
}

.FieldsViewControlsMobile-filters {
	display: flex;
	flex-direction: column;
	width: 100%;
	height: 100%;
	background: #fff;
	margin-top: 56px; /* toolbar height */
	margin-bottom: 44px; /* view results button height */

	.FieldsViewControlsMobile-control {
		min-width: 150px;

		&:first-child {
			margin-top: 8px;
		}
		&:not(:first-child) {
			margin-top: 16px;
		}
	}

	.FieldsViewControlsMobile-clearAll {
		margin: 16px 0;
	}

	.FieldsViewControlsMobile-viewResults {
		position: fixed;
		bottom: 0;
		width: 100%;
	}
}
</style>
